/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * Revision 1.1.4.2  1994/04/08  19:05:21  Susan_Ng
 * 	code drop for post-Sterling fixes/I18N changes
 * 	[1994/04/07  18:19:05  Susan_Ng]
 *
 * Revision 1.1.2.1  1992/11/12  15:29:42  devrcs
 * 	Fix revision
 * 
 * Revision 1.1  90/01/01  00:00:00  devrcs
 * 	Initial load into Alpha pool
 * 
 * Revision 1.2  91/12/30  12:48:20  devbld
 * 	Initial load of project
 * 
 */
/*
 * Copyright 1988 by Digital Equipment Corporation, Maynard, Massachusetts.
 * 
 *                         All Rights Reserved
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*
 *
 *	dxdiff
 *
 *	filestuff.h - include file for file handling
 *
 *	Author:	Laurence P. G. Cable
 *
 *	Created : 25th April 1988
 *
 *
 *	Description
 *	-----------
 *
 *
 *	Modification History
 *	------------ -------
 *	
 */

#ifndef	FILESTUFF_H
#define	FILESTUFF_H

#ifdef WIN32
#define off_t   _off_t
typedef char    *caddr_t;
#endif

typedef	struct _highlightinfo	{
	XmTextPosition	left,
			right;
	XmHighlightMode	mode;
} HighLightInfo, *HighLightInfoPtr;

typedef	struct _edc *ForwardEdcPtr;	/* we need this forward dec'l */

typedef	struct _fileinfo	{
	char			*path;		/* file name */
	char			*data;		/* ptr to the data */

	ForwardEdcPtr		dlhead,	
					    dltail;		/* the diff list */

	HighLightInfoPtr	hlp;		/* highlight list */

	off_t			filesize;	/* how long ? */
	time_t			modtime;	/* not really interesting ? */
	unsigned int		numlines;	/* number of lines */
	unsigned short		widestline;	/* width of widest */
}	FileInfo, *FileInfoPtr;

#ifdef WIN32
void err_sys(char *msg);
#endif WIN32

#endif	FILESTUFF.H
