/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * Revision 1.1  1995/03/07  23:16:19  bourquard
 * Original OSF sources
 *
 * Revision 1.1.4.2  1994/04/08  19:07:30  Susan_Ng
 * 	code drop for post-Sterling fixes/I18N changes
 * 	[1994/04/07  18:23:01  Susan_Ng]
 *
 * Revision 1.1.2.1  1992/11/12  15:29:56  devrcs
 * 	Fix revision
 * 
 * Revision 1.1  90/01/01  00:00:00  devrcs
 * 	Initial load into Alpha pool
 * 
 * Revision 1.2  91/12/30  12:48:20  devbld
 * 	Initial load of project
 * 
 */
/*
 * Copyright 1988 by Digital Equipment Corporation, Maynard, Massachusetts.
 * 
 *                         All Rights Reserved
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*
 *
 *	dxdiff
 *
 *	vscrollbar.c - vertical scroll bar code!
 *
 *	Author:	Laurence P. G. Cable
 *
 *	Created : 5th May 1988
 *
 *
 *	Description
 *	-----------
 *
 *
 *	Modification History
 *	------------ -------
 *	
 */

static char sccsid[] = "@(#)vscrollbarcbs.c	1.5	17:45:56 2/21/89";

#include <sys/types.h>
#include <sys/stat.h>

#ifdef  DEBUG
#include <stdio.h>
#endif  DEBUG
#include <X11/Xlib.h>
#include <Xm/Xm.h>
#include "dxdiff.h"
#include "arglists.h"
#include "y.tab.h"
#include "filestuff.h"
#include "parsediff.h"
#include "alloc.h"
#include "differencebox.h"
#include "menu.h"
#include "text.h"
#include "display.h"

/*************************** Private Routines ****************************/

/********************************
 *
 *	VScrollBarUnitIncCallBack
 *
 ********************************/


VScrollBarUnitIncCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarUnitIncCallbackList[] = {
	{ (VoidProc)VScrollBarUnitIncCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};


/********************************
 *
 *	VScrollBarUnitDecCallBack
 *
 ********************************/


VScrollBarUnitDecCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarUnitDecCallbackList[] = {
	{ (VoidProc)VScrollBarUnitDecCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarPageIncCallBack
 *
 ********************************/


VScrollBarPageIncCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarPageIncCallbackList[] = {
	{ (VoidProc)VScrollBarPageIncCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarPageDecCallBack
 *
 ********************************/


VScrollBarPageDecCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarPageDecCallbackList[] = {
	{ (VoidProc)VScrollBarPageDecCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarToTopCallBack
 *
 ********************************/


VScrollBarToTopCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
}

XtCallbackRec VScrollBarToTopCallbackList[] = {
	{ (VoidProc)VScrollBarToTopCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarToBottomCallBack
 *
 ********************************/


VScrollBarToBottomCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
}

XtCallbackRec VScrollBarToBottomCallbackList[] = {
	{ (VoidProc)VScrollBarToBottomCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarDragCallBack
 *
 ********************************/


VScrollBarDragCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarDragCallbackList[] = {
	{ (VoidProc)VScrollBarDragCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};



/********************************
 *
 *	VScrollBarValueChangedCallBack
 *
 ********************************/


VScrollBarValueChangedCallBack(w, clientd, calld)
	register Widget	w;
	caddr_t		clientd;
	caddr_t		calld;
{
	DoScrollFromCallBack(w, clientd, calld);
}

XtCallbackRec VScrollBarValueChangedCbkList[] = {
	{ (VoidProc)VScrollBarValueChangedCallBack, NULL },
	{ (VoidProc)NULL, NULL }
};
